Summary: Open implementation of Service Location Protocol V2
Name:    openslp
Version: 2.0.0
Release: 4%{?dist}
License: BSD
URL:     http://sourceforge.net/projects/openslp/
Source0: http://downloads.sf.net/openslp/openslp-%{version}.tar.gz
Source2: slpd.8.gz
Source3: slptool.1.gz
Source4: slpd.service

Patch3001: openslp-2.0.0-multicast-set.patch
Patch3002: openslp-2.0.0-notify-systemd-of-start-up.patch
Patch3003: openslp-2.0.0-null-pointer-deref.patch
Patch3004: openslp-2.0.0-openssl-1.1-fix.patch
Patch3005: openslp-2.0.0-cve-2016-7567.patch
Patch3006: openslp-2.0.0-cve-2017-17833.patch
Patch3007: openslp-2.0.0-cve-2019-5544.patch

BuildRequires: make automake libtool bison flex openssl-devel systemd-units systemd-devel

%description
Service Location Protocol is an IETF standards track protocol that provides a framework to allow
networking applications to discover the existence, location, and configuration of networked services
in enterprise networks.

OpenSLP is an open source implementation of the SLPv2 protocol as defined by RFC 2608 and RFC 2614.

%package devel
Summary: OpenSLP headers and libraries
Requires: %{name} = %{version}-%{release}

%description devel
OpenSLP header files and libraries.

%package server
Summary: OpenSLP server daemon
Requires: %{name} = %{version}-%{release}
Requires: iproute

%description server
OpenSLP server daemon to dynamically register services.

%prep
%autosetup -n %{name}-%{version} -p1

%build
autoreconf -f -i
find . -name "CVS" | xargs rm -rf

export CFLAGS="-fPIC -fno-strict-aliasing -fPIE -DPIE $RPM_OPT_FLAGS"
export LDFLAGS="-pie -Wl,-z,now"

%configure \
  --prefix=%{_prefix} \
  --libdir=%{_libdir} \
  --sysconfdir=%{_sysconfdir} \
  --localstatedir=/var \
  --disable-dependency-tracking \
  --disable-static \
  --disable-rpath \
  --enable-async-api

%make_build

%install
rm -rf %{buildroot}
%make_install

mkdir -p %{buildroot}/%{_sysconfdir}/slp.reg.d
install -Dm 0755 etc/slpd.all_init %{buildroot}/usr/lib/%{name}-server/slp-multicast-set.sh

install -p -Dm 644 %{SOURCE4} %{buildroot}/%{_unitdir}/slpd.service
install -Dp %{SOURCE3} %{buildroot}/%{_mandir}/man1/slptool.1.gz
install -Dp %{SOURCE2} %{buildroot}/%{_mandir}/man8/slpd.8.gz

rm -rf %{buildroot}/usr/doc
rm -f  %{buildroot}%{_libdir}/lib*.la

%post server
%systemd_post slpd.service

%preun server
%systemd_preun slpd.service

%postun server
%systemd_postun_with_restart slpd.service

%files
%license COPYING
%doc AUTHORS FAQ NEWS README THANKS
%config(noreplace) %{_sysconfdir}/slp.conf
%{_bindir}/slptool
%{_libdir}/libslp.so.1*
%{_mandir}/man1/*

%files server
%config(noreplace) %{_sysconfdir}/slp.reg
%config(noreplace) %{_sysconfdir}/slp.spi
%{_unitdir}/slpd.service
%{_sbindir}/slpd
/usr/lib/%{name}-server/slp-multicast-set.sh
%{_mandir}/man8/*

%files devel
%doc doc/doc/rfc
%{_includedir}/slp.h
%{_libdir}/libslp.so

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.0.0-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.0.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.0.0-2
- Rebuilt for OpenCloudOS Stream 23

* Tue Mar 14 2023 Shuo Wang <abushwang@tencent.com> - 2.0.0-1
- initial build
